//this source code was auto-generated by tolua#, do not modify it
using System;
using LuaInterface;

public class CLASSTAG_HudWrap
{
	public static void Register(LuaState L)
	{
		L.BeginClass(typeof(Hud), typeof(UnityEngine.MonoBehaviour));
		L.RegFunction("CallUpdateAll",FUNCTAG_CallUpdateAll);
		L.RegFunction("Start",FUNCTAG_Start);
		L.RegFunction("OnDestroy",FUNCTAG_OnDestroy);
		L.RegFunction("CheckShow",FUNCTAG_CheckShow);
		L.RegFunction("ResetHud",FUNCTAG_ResetHud);
		L.RegFunction("BatchCall",FUNCTAG_BatchCall);
		L.RegVar("target",FUNCTAG_get_target, FUNCTAG_set_target);
		L.RegVar("gameCamera",FUNCTAG_get_gameCamera, FUNCTAG_set_gameCamera);
		L.RegVar("uiCamera",FUNCTAG_get_uiCamera, FUNCTAG_set_uiCamera);
		L.RegVar("isAutoUpdate",FUNCTAG_get_isAutoUpdate, FUNCTAG_set_isAutoUpdate);
		L.RegVar("walkerEventHandler",FUNCTAG_get_walkerEventHandler, FUNCTAG_set_walkerEventHandler);
		L.EndClass();
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_CallUpdateAll(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 0);
			Hud.CallUpdateAll();
			return 0;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_Start(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			Hud obj = (Hud)ToLua.CheckObject(L, 1, typeof(Hud));
			obj.Start();
			return 0;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_OnDestroy(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			Hud obj = (Hud)ToLua.CheckObject(L, 1, typeof(Hud));
			obj.OnDestroy();
			return 0;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_CheckShow(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			Hud obj = (Hud)ToLua.CheckObject(L, 1, typeof(Hud));
			obj.CheckShow();
			return 0;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_ResetHud(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			Hud obj = (Hud)ToLua.CheckObject(L, 1, typeof(Hud));
			obj.ResetHud();
			return 0;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_get_target(IntPtr L)
	{
		object o = null;

		try
		{
			o = ToLua.ToObject(L, 1);
			Hud obj = (Hud)o;
			UnityEngine.Transform ret = obj.target;
			ToLua.Push(L, ret);
			return 1;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e, o == null ? "attempt to index target on a nil value" : e.Message);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_get_gameCamera(IntPtr L)
	{
		object o = null;

		try
		{
			o = ToLua.ToObject(L, 1);
			Hud obj = (Hud)o;
			UnityEngine.Camera ret = obj.gameCamera;
			ToLua.Push(L, ret);
			return 1;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e, o == null ? "attempt to index gameCamera on a nil value" : e.Message);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_get_uiCamera(IntPtr L)
	{
		object o = null;

		try
		{
			o = ToLua.ToObject(L, 1);
			Hud obj = (Hud)o;
			UnityEngine.Camera ret = obj.uiCamera;
			ToLua.Push(L, ret);
			return 1;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e, o == null ? "attempt to index uiCamera on a nil value" : e.Message);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_get_isAutoUpdate(IntPtr L)
	{
		object o = null;

		try
		{
			o = ToLua.ToObject(L, 1);
			Hud obj = (Hud)o;
			bool ret = obj.isAutoUpdate;
			LuaDLL.lua_pushboolean(L, ret);
			return 1;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e, o == null ? "attempt to index isAutoUpdate on a nil value" : e.Message);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_get_walkerEventHandler(IntPtr L)
	{
		object o = null;

		try
		{
			o = ToLua.ToObject(L, 1);
			Hud obj = (Hud)o;
			WalkerEventHandler ret = obj.walkerEventHandler;
			ToLua.Push(L, ret);
			return 1;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e, o == null ? "attempt to index walkerEventHandler on a nil value" : e.Message);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_set_target(IntPtr L)
	{
		object o = null;

		try
		{
			o = ToLua.ToObject(L, 1);
			Hud obj = (Hud)o;
			UnityEngine.Transform arg0 = (UnityEngine.Transform)ToLua.CheckUnityObject(L, 2, typeof(UnityEngine.Transform));
			obj.target = arg0;
			return 0;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e, o == null ? "attempt to index target on a nil value" : e.Message);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_set_gameCamera(IntPtr L)
	{
		object o = null;

		try
		{
			o = ToLua.ToObject(L, 1);
			Hud obj = (Hud)o;
			UnityEngine.Camera arg0 = (UnityEngine.Camera)ToLua.CheckUnityObject(L, 2, typeof(UnityEngine.Camera));
			obj.gameCamera = arg0;
			return 0;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e, o == null ? "attempt to index gameCamera on a nil value" : e.Message);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_set_uiCamera(IntPtr L)
	{
		object o = null;

		try
		{
			o = ToLua.ToObject(L, 1);
			Hud obj = (Hud)o;
			UnityEngine.Camera arg0 = (UnityEngine.Camera)ToLua.CheckUnityObject(L, 2, typeof(UnityEngine.Camera));
			obj.uiCamera = arg0;
			return 0;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e, o == null ? "attempt to index uiCamera on a nil value" : e.Message);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_set_isAutoUpdate(IntPtr L)
	{
		object o = null;

		try
		{
			o = ToLua.ToObject(L, 1);
			Hud obj = (Hud)o;
			bool arg0 = LuaDLL.luaL_checkboolean(L, 2);
			obj.isAutoUpdate = arg0;
			return 0;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e, o == null ? "attempt to index isAutoUpdate on a nil value" : e.Message);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_set_walkerEventHandler(IntPtr L)
	{
		object o = null;

		try
		{
			o = ToLua.ToObject(L, 1);
			Hud obj = (Hud)o;
			WalkerEventHandler arg0 = (WalkerEventHandler)ToLua.CheckUnityObject(L, 2, typeof(WalkerEventHandler));
			obj.walkerEventHandler = arg0;
			return 0;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e, o == null ? "attempt to index walkerEventHandler on a nil value" : e.Message);
		}
	}

	public enum BactchCallFuncType
	{
		target = 1,
		gameCamera = 2,
		uiCamera = 3,
		isAutoUpdate = 4,
		walkerEventHandler = 5,
		ResetHud = 6,
	}

	private static void CallOne(Hud obj, Action<Hud> action)
	{
		try
		{
			if (obj != null)
			{
				action(obj);
			}
		}
		catch (Exception e)
		{
			GameDebug.LogError(e.ToString());
		}
	}
	private static int CallByType(IntPtr L, int objId, BactchCallFuncType funcType, int argIdx)
	{
		Hud obj = Hud.GetBatchObject(objId);
		switch (funcType)
		{
			case BactchCallFuncType.target:
				CallOne(obj, (o) =>{ o.target = ToLua.ToObject(L, argIdx + 1) as UnityEngine.Transform; });
				return 1;
			case BactchCallFuncType.gameCamera:
				CallOne(obj, (o) => { o.gameCamera = ToLua.ToObject(L, argIdx + 1) as UnityEngine.Camera; });
				return 1;
			case BactchCallFuncType.uiCamera:
				CallOne(obj, (o) => { o.uiCamera = ToLua.ToObject(L, argIdx + 1) as UnityEngine.Camera; });
				return 1;
			case BactchCallFuncType.isAutoUpdate:
				CallOne(obj, (o) => { o.isAutoUpdate = LuaDLL.luaL_checkboolean(L, argIdx + 1); });
				return 1;
			case BactchCallFuncType.walkerEventHandler:
				CallOne(obj, (o) => { o.walkerEventHandler = ToLua.ToObject(L, argIdx + 1) as WalkerEventHandler; });
				return 1;

			case BactchCallFuncType.ResetHud:
				CallOne(obj, (o) => { o.ResetHud(); });
				return 0;
			default:
				Debugger.LogError("unprocess batch call:" + funcType);
				return 0;
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	public static int FUNCTAG_BatchCall(IntPtr L)
	{
		try
		{
			int argIdx = 0;
			int callCnt = LuaDLL.lua_tointeger(L, ++argIdx);
			for (int i = 0; i < callCnt; i++)
			{
				int objId = LuaDLL.lua_tointeger(L, ++argIdx);
				BactchCallFuncType funcType = (BactchCallFuncType)LuaDLL.lua_tointeger(L, ++argIdx);
				argIdx = argIdx + CallByType(L, objId, funcType, argIdx);
			}
			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}
}

